#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>

#define MAXCLIENTS 256
#define PLUGIN_VERSION "3.0.1"

#define YELLOW 0x01
#define TEAMCOLOR 0x02
#define LIGHTGREEN 0x03
#define GREEN 0x04

new Handle:g_hptime=INVALID_HANDLE;
new Handle:Timers[MAXCLIENTS+1];
new Handle:Timerhp[MAXCLIENTS+1];
new Handle:TimerReghp[MAXCLIENTS+1];
new bool:AuraOnOff[MAXCLIENTS+1];
new g_BeamSprite1,
	g_HaloSprite1,
	g_BeamSprite2,
	g_HaloSprite2,
	g_BeamSprite3,
	g_HaloSprite3;
new	bool:AuraAuth[MAXCLIENTS+1];
new colorrclient[MAXCLIENTS+1],
	colorgclient[MAXCLIENTS+1],
	colorbclient[MAXCLIENTS+1],
	coloraclient[MAXCLIENTS+1],
	auratype[MAXCLIENTS+1];
new addHealthclient[MAXCLIENTS+1];
new regHealthclient[MAXCLIENTS+1];
new Float:RegenTimer[MAXCLIENTS+1];
new Float:addSpeedclient[MAXCLIENTS+1],
	Float:addGravityclient[MAXCLIENTS+1];
new	clientcolorr[MAXCLIENTS+1],
	clientcolorg[MAXCLIENTS+1],
	clientcolorb[MAXCLIENTS+1],
	clientcolora[MAXCLIENTS+1];
new	menu_color_r[67],
	menu_color_g[67],
	menu_color_b[67],
	menu_color_a[67];
new precache_laser;	

//////
//db//
//////
new String:sql_createTables[] = "CREATE TABLE IF NOT EXISTS aura (steamid VARCHAR(32) PRIMARY KEY, ID int(12), name VARCHAR(128), colorr int(12), colorg int(12), colorb int(12), alpha int(12), type int(12), hp int(12), speed int(12), grav int(12), reg int(12), regentimer int(12), clientcolorr int(12), clientcolorg int(12), clientcolorb int(12), clientalpha int(12));";
new String:sql_updatePlayerColor[] = "UPDATE aura SET colorr = '%d', colorg = '%d', colorb = '%d', alpha = '%d', type = '%d' WHERE steamid = '%s';";
new String:sql_TakePlayer[] = "SELECT colorr, colorg, colorb, alpha, hp, reg, type, regentimer, speed, grav, clientcolorr, clientcolorg, clientcolorb, clientalpha FROM aura WHERE steamid='%s';";
new String:sql_updatePlayerName[] = "UPDATE aura SET name = '%s' WHERE steamid = '%s';";

//new g_DbType; //в плагине нет ф-ций которые различаются в sqlite и mysql.
new Handle:g_hDb = INVALID_HANDLE;

#define MYSQL 0
#define SQLITE 1

//
//
//

public Plugin:myinfo = {
	name = "Aura from db",
	author = "SemJeF", 
	description = "Setup Aura on clients from database",
	version = PLUGIN_VERSION,
	url = "http://flowzet.ru/"
};

public OnPluginStart()
{
	CreateConVar("Aura_db_version", PLUGIN_VERSION, "Setup Aura on clients from database", FCVAR_PLUGIN|FCVAR_NOTIFY);
	
	LoadTranslations("aura.phrases");
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_hurt", Player_Hurt);
	
	g_hptime = CreateConVar("aura_hp_timer","0"); // таймер на добавление здоровья. Cделал для ДМ серверов
	
	db_setupDatabase();
	
	RegConsoleCmd("glow_toggle", Command_Toggle);
	RegConsoleCmd("aura_toggle", Command_Toggle);
	RegConsoleCmd("glow_color", Command_Color);
	RegConsoleCmd("aura_color", Command_Color);
	RegConsoleCmd("glow_getcolor", Command_GetColor);
	RegConsoleCmd("aura_getcolor", Command_GetColor);
	RegConsoleCmd("glow_menu", Command_Menu);
	RegConsoleCmd("aura_menu", Command_Menu);
}

////////
//aura//
////////

public OnClientPutInServer(client)
{
	AuraAuth[client] 	= false;
	AuraOnOff[client]	= true;
	db_selectPlayer(client);
}

after_db_selectPlayer(client)
{
	if(AuraAuth[client] && IsClientInGame(client))
	{
		db_getclient(client);
		
		decl String:clientname[128];
		decl String:szQuery[255];
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);
		GetClientName(client,clientname,sizeof(clientname));
		Format(szQuery, 255, sql_updatePlayerName, clientname, szSteamId);
		SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
	}
}

public db_selectPlayer(client)
{
	decl String:szQuery[255];
	decl String:szSteamId[32];
	GetClientAuthString(client, szSteamId, 32);
	Format(szQuery, 255, "SELECT * FROM aura WHERE steamid ='%s'", szSteamId);
	SQL_TQuery(g_hDb, SQL_SelectPlayerCallback, szQuery, client);
}

public SQL_SelectPlayerCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
	{
		LogError("[Aura_db] Error loading player (%s)", error);
	}	
	else
	{
		new client = data;
		if(SQL_HasResultSet(hndl) && SQL_FetchRow(hndl) && IsClientInGame(client))
		{	
			AuraAuth[client] = true;
		}	
		else
		{
			AuraAuth[client] = false;
		}
		after_db_selectPlayer(client);
	}
}

public db_getclient(client)
{
	decl String:SteamId[32];
	GetClientAuthString(client, SteamId, 32);
	new String:query[512];    
	Format(query, sizeof(query), sql_TakePlayer, SteamId);   // берём данные клиента из базы 
	new Handle:hquery = SQL_Query(g_hDb, query);    
	if (hquery != INVALID_HANDLE && SQL_FetchRow(hquery))    
	{    
		colorrclient[client] 		= 	SQL_FetchInt(hquery, 0);    
		colorgclient[client] 		= 	SQL_FetchInt(hquery, 1);    
		colorbclient[client] 		= 	SQL_FetchInt(hquery, 2);    
		coloraclient[client] 		= 	SQL_FetchInt(hquery, 3);    
		addHealthclient[client] 	= 	SQL_FetchInt(hquery, 4); 
		regHealthclient[client]		= 	SQL_FetchInt(hquery, 5);
		auratype[client] 			= 	SQL_FetchInt(hquery, 6); 
		RegenTimer[client] 			= 	SQL_FetchFloat(hquery, 7); 
		addSpeedclient[client] 		= 	SQL_FetchFloat(hquery, 8); 
		addGravityclient[client] 	= 	SQL_FetchFloat(hquery, 9);
		clientcolorr[client] 		= 	SQL_FetchInt(hquery, 10);
		clientcolorg[client] 		= 	SQL_FetchInt(hquery, 11);
		clientcolorb[client] 		=	SQL_FetchInt(hquery, 12);
		clientcolora[client] 		= 	SQL_FetchInt(hquery, 13);
	} 
	else
	{
	}
	CloseHandle(hquery);  
}

public OnMapStart()
{
	precache_laser = PrecacheModel("materials/sprites/laserbeam.vmt");
	// Сделал новый формат подгрузки текстур для аур для того чтоб вы, уважаемые юзеры могли подобрать свои собственные
	// Если наёдёте хорошие текстуры, пожалуйста, поделитесь ими на форуме http://hlmod.ru/forum/plaginy-dlya-sourcemod/7197-aura-database-v-2-1-a.html
	new	String:aurabmodel[5][256];	
	new	String:aurahmodel[5][256];	
	new String:file[255];
	BuildPath(Path_SM, file, 255, "configs/aura_db/auramodels.ini");
	new Handle:kv = CreateKeyValues("Auramodels");
	FileToKeyValues(kv, file);
	if (KvGotoFirstSubKey(kv))
	{
		new index = 1;
		do
		{
			KvGetString(kv, "model1", aurabmodel[index], 256);	
			KvGetString(kv, "model2", aurahmodel[index], 256);
			index++;
		}
		while (KvGotoNextKey(kv));
		g_BeamSprite1 = PrecacheModel(aurabmodel[1]);
		g_HaloSprite1 = PrecacheModel(aurahmodel[1]);
		g_BeamSprite2 = PrecacheModel(aurabmodel[2]);
		g_HaloSprite2 = PrecacheModel(aurahmodel[2]);
		g_BeamSprite3 = PrecacheModel(aurabmodel[3]);
		g_HaloSprite3 = PrecacheModel(aurahmodel[3]);
	}
	CloseHandle(kv);
}

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	StopTimerhp(client);
	if (AuraAuth[client])
	{
		if (AuraOnOff[client] && Timers[client] == INVALID_HANDLE)
		{
			Timers[client] = CreateTimer(0.05, Timer_Beacon, client, TIMER_REPEAT);
			PrintToChat(client, "%t","glow_on",LIGHTGREEN,YELLOW,GREEN);
			PrintToChat(client, "%t","glow_change",LIGHTGREEN,YELLOW,GREEN,YELLOW,GREEN);
		}
		Timerhp[client] = CreateTimer(GetConVarFloat(g_hptime), TimerHpadd, client); // таймер на добавление здоровья. Cделал для ДМ серверов
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", GetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue") + addSpeedclient[client]*0.01); //установка скорости
		SetEntityGravity(client, (1.0 - addGravityclient[client]*0.01)); //установка гравитации
		SetEntityRenderColor(client, clientcolorr[client], clientcolorg[client], clientcolorb[client], clientcolora[client]);
		SetEntityRenderMode(client, RENDER_TRANSCOLOR);
		StopRegen(client);
	}
}

public Action:TimerHpadd(Handle:timer, any:client) // что делает таймер выдачи хп...
{ 
	Timerhp[client] = INVALID_HANDLE;
	if (IsPlayerAlive(client))
	{
		SetEntityHealth(client, GetClientHealth(client) + addHealthclient[client]); 
	}
} 

public Player_Hurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (AuraAuth[client] && TimerReghp[client] == INVALID_HANDLE)
	{
		TimerReghp[client] = CreateTimer(RegenTimer[client] , RegenHP, client);
	}
}

public Action:RegenHP(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		TimerReghp[client] = INVALID_HANDLE;
		if (GetClientHealth(client) < (100 + addHealthclient[client] - regHealthclient[client]))
		{
			SetEntityHealth(client, GetClientHealth(client) + regHealthclient[client]);
			TimerReghp[client] = CreateTimer(RegenTimer[client] , RegenHP, client);
			return Plugin_Continue;
		}
		else
		{
			SetEntityHealth(client, 100 + addHealthclient[client]);
		}
	}
	else
	{
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

public Action:Command_Color(client, args)
{
	if (args != 5)
	{
		PrintToConsole(client, "%t","glow_inc");
		return Plugin_Handled;
	}
	else
	{
		if (AuraAuth[client])
		{
			new String:Arg1[32], String:Arg2[32], String:Arg3[32], String:Arg4[32], String:Arg5[32];
		
			GetCmdArg(1, Arg1, sizeof(Arg1));
			GetCmdArg(2, Arg2, sizeof(Arg2));
			GetCmdArg(3, Arg3, sizeof(Arg3));
			GetCmdArg(4, Arg4, sizeof(Arg4));
			GetCmdArg(5, Arg5, sizeof(Arg5));
			
			colorrclient[client] 	= StringToInt(Arg1);  
			colorgclient[client] 	= StringToInt(Arg2);  
			colorbclient[client] 	= StringToInt(Arg3);  
			coloraclient[client] 	= StringToInt(Arg4);  
			auratype[client] 		= StringToInt(Arg5);
			
			decl String:szQuery[255];
			decl String:szSteamId[32];
			GetClientAuthString(client, szSteamId, 32);
			Format(szQuery, 255, sql_updatePlayerColor, colorrclient[client], colorgclient[client], colorbclient[client], coloraclient[client], auratype[client], szSteamId);
			SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
			PrintToChat(client, "%t", "glow_ok", LIGHTGREEN,YELLOW);
		}	
		else
		{
			PrintToChat(client, "%t","glow_cannot",LIGHTGREEN,YELLOW);
			return Plugin_Handled;
		}
	}
	return Plugin_Handled;
}

public Action:Command_GetColor(client, args)
{
	if (AuraAuth[client])
	{ 
		new r, g, b, a, t;        
		r = colorrclient[client];  
		g = colorgclient[client];  
		b = colorbclient[client];  
		a = coloraclient[client];  
		t = auratype[client];
		PrintToConsole(client, "%t","glow_get", LIGHTGREEN,YELLOW,GREEN,r, g, b, a, t);
		PrintToChat(client, "%t","glow_get", LIGHTGREEN,YELLOW,GREEN,r, g, b, a, t);
	}
	else
	{
		PrintToChat(client, "%t","glow_cannot",LIGHTGREEN,YELLOW);
		return Plugin_Handled;
	}
	return Plugin_Handled;
}

bool:ReadColor(client, color[4]) //выводим цвета в color[4]
{    
	color[0] = colorrclient[client];    
	color[1] = colorgclient[client];    
	color[2] = colorbclient[client];    
	color[3] = coloraclient[client]; 
	return true; 
}    

public Action:Timer_Beacon(Handle:timer, any:client)  // таймер ауры
{	
	new color[4]; 
	if (IsPlayerAlive(client) && ReadColor(client, color))
	{
		if (auratype[client] == 1) // если тип = 1 то ставим "тип 1" 
		{
			SetupBeacon1(client, color);  
		}
		else if (auratype[client] == 2) // если нет, то проверяем равен ли тип 2, если да то ставим ауру "тип 2"
		{
			SetupBeacon2(client, color);  
		}
		else if (auratype[client] == 3) 
		{
			SetupBeacon3(client, color);  
		}
		else if (auratype[client] == 4) 
		{
			SetupBeacon4(client, color);  
		}
		else // если тип не равен ниодному из выше перечисленых то ставим "тип 3"
		{
			SetupBeacon3(client, color);
		}
	}
	else
	{
	}
	return Plugin_Continue; 
}

SetupBeacon1(client, color[4])  
{  
	new Float:vec[3];  
	GetClientAbsOrigin(client, vec);  
	vec[2] += 10; 
	TE_SetupBeamRingPoint(vec, 50.0, 60.0, g_BeamSprite1, g_HaloSprite1, 0, 15, 0.1, 10.0, 0.0, color, 10, 0);  
	TE_SendToAll();  
}  
SetupBeacon2(client, color[4])  
{  
	new Float:vec[3];  
	GetClientAbsOrigin(client, vec);  
	vec[2] += 10; 
	TE_SetupBeamRingPoint(vec, 50.0, 60.0, g_BeamSprite2, g_HaloSprite2, 0, 15, 0.1, 10.0, 0.0, color, 10, 0);  
	TE_SendToAll();  
} 
SetupBeacon3(client, color[4])  
{  
	new Float:vec[3];  
	GetClientAbsOrigin(client, vec);  
	vec[2] += 10; 
	TE_SetupBeamRingPoint(vec, 50.0, 60.0, g_BeamSprite3, g_HaloSprite3, 0, 15, 0.1, 10.0, 0.0, color, 10, 0);  
	TE_SendToAll();  
}
SetupBeacon4(client, color[4])  
{  
	TE_SetupBeamFollow(client, precache_laser, 0, 0.5, 1.0, 1.0, 1, color);
	TE_SendToAll();  
}

public Action:Command_Toggle(client, args)
{
	if (AuraAuth[client])
	{
		if (AuraOnOff[client])
		{
			AuraOnOff[client]	= false;
			CloseHandle(Timers[client]);
			Timers[client]		= INVALID_HANDLE;
			PrintToChat(client, "%t","glow_off",LIGHTGREEN,YELLOW,GREEN);
		}
		else
		{
			AuraOnOff[client]	= true;
			Timers[client]		= CreateTimer(0.05, Timer_Beacon, client, TIMER_REPEAT);
			PrintToChat(client, "%t","glow_on",LIGHTGREEN,YELLOW,GREEN);
		}
	}
	else
	{
		PrintToChat(client, "%t","glow_cannot",LIGHTGREEN,YELLOW);
		return Plugin_Handled;
	}
	return Plugin_Handled;
}

public Action:Command_Menu(client, args)
{
	if (AuraAuth[client])
	{ 
		DisplayMenu(BuildAuraMenu(client), client, 60);
	}
	else
	{
		PrintToChat(client, "%t","glow_cannot",LIGHTGREEN,YELLOW);
		return Plugin_Handled;
	}
	return Plugin_Handled;
}

stock Handle:BuildAuraMenu(client)
{
	decl String:item[256];
	new Handle:menu = CreateMenu(AuraMenuHandler);
	SetMenuTitle(menu, "%T\n------------------------", "MainMenu_Title", client);
	Format(item, sizeof(item), "%T", "MainMenu_colors", client);
	AddMenuItem(menu, "colors", item);
	Format(item, sizeof(item), "%T", "MainMenu_dorabotka", client);
	AddMenuItem(menu, "dorabotka", item, ITEMDRAW_DISABLED);
	SetMenuExitButton(menu, true);
	return menu;
}

public AuraMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select && AuraAuth[client])
	{
		decl String:info[64], String:name[64];
		GetMenuItem(menu, param2, info, sizeof(info));
		GetClientName(client, name, sizeof(name));
		if (StrEqual(info, "colors"))
		{
			DisplayMenu(BuildColorsMenu(client), client, 60);
		}
		else if (StrEqual(info, "dorabotka"))
		{
			
		}
	}	
}

stock Handle:BuildColorsMenu(client)
{
	decl String:item[256];
	new Handle:menu = CreateMenu(ColorsMenuHandler);
	SetMenuTitle(menu, "%T\n------------------------", "ColorsMenu_Title", client);
	Format(item, sizeof(item), "%T", "ColorsMenu_type", client);
	AddMenuItem(menu, "type", item);
	Format(item, sizeof(item), "%T", "ColorsMenu_red", client);
	AddMenuItem(menu, "red", item);
	Format(item, sizeof(item), "%T", "ColorsMenu_green", client);
	AddMenuItem(menu, "green", item);
	Format(item, sizeof(item), "%T", "ColorsMenu_blue", client);
	AddMenuItem(menu, "blue", item);
	
	decl String:file[255];
	new Handle:kv = CreateKeyValues("ColorsMenu");
	BuildPath(Path_SM, file, sizeof(file), "configs/aura_db/aura_menus.ini");
	FileToKeyValues(kv, file);
	if (KvGotoFirstSubKey(kv))
	{
		new index = 1;
		decl String:buffer[255];
		decl String:bufferindex[5];
		do
		{
			menu_color_r[index] = KvGetNum(kv, "color_r");
			menu_color_g[index] = KvGetNum(kv, "color_g");
			menu_color_b[index] = KvGetNum(kv, "color_b");
			menu_color_a[index] = KvGetNum(kv, "color_a");
			KvGetSectionName(kv, buffer, sizeof(buffer));
			IntToString(index, bufferindex, sizeof(bufferindex));
			AddMenuItem(menu, bufferindex, buffer);
			index++;
		}
		while (KvGotoNextKey(kv));
	}
	CloseHandle(kv);
	
	Format(item, sizeof(item), "%T", "random", client);
	AddMenuItem(menu, "random", item);
	
	SetMenuExitButton(menu, true);
	return menu;
}

public ColorsMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select && AuraAuth[client])
	{
		decl String:info[64], String:name[64];
		GetMenuItem(menu, param2, info, sizeof(info));
		GetClientName(client, name, sizeof(name));
		decl String:szQuery[255];
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);
		if (StrEqual(info, "type"))
		{
			DisplayMenu(BuildTypeMenu(client), client, 60);
		}
		else if (StrEqual(info, "red"))
		{
			colorrclient[client] = 255;  
			colorgclient[client] = 75;  
			colorbclient[client] = 0;  
			coloraclient[client] = 255; 
			Format(szQuery, 255, sql_updatePlayerColor, colorrclient[client], colorgclient[client], colorbclient[client], coloraclient[client], auratype[client], szSteamId);
			SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
			PrintToChat(client, "%t", "glow_ok", LIGHTGREEN,YELLOW);
		}
		else if (StrEqual(info, "green"))
		{
			colorrclient[client] = 0;  
			colorgclient[client] = 255;  
			colorbclient[client] = 25;  
			coloraclient[client] = 255; 
			Format(szQuery, 255, sql_updatePlayerColor, colorrclient[client], colorgclient[client], colorbclient[client], coloraclient[client], auratype[client], szSteamId);
			SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
			PrintToChat(client, "%t", "glow_ok", LIGHTGREEN,YELLOW);
		}
		else if (StrEqual(info, "blue"))
		{
			colorrclient[client] = 0;  
			colorgclient[client] = 50;  
			colorbclient[client] = 255;  
			coloraclient[client] = 255; 
			Format(szQuery, 255, sql_updatePlayerColor, colorrclient[client], colorgclient[client], colorbclient[client], coloraclient[client], auratype[client], szSteamId);
			SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
			PrintToChat(client, "%t", "glow_ok", LIGHTGREEN,YELLOW);
		}
		else if (StrEqual(info, "random"))
		{
			colorrclient[client] = GetRandomInt(0,255);  
			colorgclient[client] = GetRandomInt(0,255);  
			colorbclient[client] = GetRandomInt(0,255);  
			coloraclient[client] = GetRandomInt(0,255); 
			Format(szQuery, 255, sql_updatePlayerColor, colorrclient[client], colorgclient[client], colorbclient[client], coloraclient[client], auratype[client], szSteamId);
			SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
			PrintToChat(client, "%t", "glow_ok", LIGHTGREEN,YELLOW);
		}
		else
		{
			new index = StringToInt(info);
			colorrclient[client] = menu_color_r[index];  
			colorgclient[client] = menu_color_g[index];  
			colorbclient[client] = menu_color_b[index];  
			coloraclient[client] = menu_color_a[index]; 
			Format(szQuery, 255, sql_updatePlayerColor, colorrclient[client], colorgclient[client], colorbclient[client], coloraclient[client], auratype[client], szSteamId);
			SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
			PrintToChat(client, "%t", "glow_ok", LIGHTGREEN,YELLOW);
		}
	}	
}

stock Handle:BuildTypeMenu(client)
{
	decl String:item[256];
	new Handle:menu = CreateMenu(TypeMenuHandler);
	SetMenuTitle(menu, "%T\n------------------------", "TypeMenu_Title", client);
	Format(item, sizeof(item), "%T", "TypeMenu_1", client);
	AddMenuItem(menu, "1", item);
	Format(item, sizeof(item), "%T", "TypeMenu_2", client);
	AddMenuItem(menu, "2", item);
	Format(item, sizeof(item), "%T", "TypeMenu_3", client);
	AddMenuItem(menu, "3", item);
	Format(item, sizeof(item), "%T", "TypeMenu_4", client);
	AddMenuItem(menu, "4", item);
	Format(item, sizeof(item), "%T", "random", client);
	AddMenuItem(menu, "random", item);
	SetMenuExitButton(menu, true);
	return menu;
}

public TypeMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_Select && AuraAuth[client])
	{
		decl String:info[64], String:name[64];
		GetMenuItem(menu, param2, info, sizeof(info));
		GetClientName(client, name, sizeof(name));
		decl String:szQuery[255];
		decl String:szSteamId[32];
		GetClientAuthString(client, szSteamId, 32);
		if (StrEqual(info, "1"))
		{
			auratype[client] = 1;
			PrintToChat(client, "%t", "glow_type_ok", LIGHTGREEN,YELLOW);
		}
		else if (StrEqual(info, "2"))
		{
			auratype[client] = 2;
			PrintToChat(client, "%t", "glow_type_ok", LIGHTGREEN,YELLOW);
		}
		else if (StrEqual(info, "3"))
		{
			auratype[client] = 3;
			PrintToChat(client, "%t", "glow_type_ok", LIGHTGREEN,YELLOW);
		}
		else if (StrEqual(info, "4"))
		{
			auratype[client] = 4;
			PrintToChat(client, "%t", "glow_type_ok", LIGHTGREEN,YELLOW);
		}
		else if (StrEqual(info, "random"))
		{
			auratype[client] = GetRandomInt(1,4);
			PrintToChat(client, "%t", "glow_type_ok", LIGHTGREEN,YELLOW);
		}
		Format(szQuery, 255, sql_updatePlayerColor, colorrclient[client], colorgclient[client], colorbclient[client], coloraclient[client], auratype[client], szSteamId);
		SQL_TQuery(g_hDb, SQL_CheckCallback, szQuery);
	}	
}

public OnClientDisconnect(client)
{
	if (Timers[client] != INVALID_HANDLE)
	{
		KillTimer(Timers[client]);
		Timers[client] = INVALID_HANDLE;
	}
	StopRegen(client);
	StopTimerhp(client);
	AuraAuth[client] 			= false;
	addHealthclient[client] 	= 0;
	addSpeedclient[client] 		= 0.0;
	addGravityclient[client] 	= 1.0;
	regHealthclient[client] 	= 0;
	clientcolorr[client] 		= 255;
	clientcolorg[client] 		= 255;
	clientcolorb[client] 		= 255;
	clientcolora[client]	 	= 255;
}

StopRegen(client)
{
	if (TimerReghp[client] != INVALID_HANDLE)
	{
		KillTimer(TimerReghp[client]);
		TimerReghp[client] = INVALID_HANDLE;
	}
}
StopTimerhp(client)
{
	if (Timerhp[client] != INVALID_HANDLE)
	{
		KillTimer(Timerhp[client]);
		Timerhp[client] = INVALID_HANDLE;
	}	
}

//----------//
// database //
//----------//
public db_setupDatabase()
{
	decl String:szError[255];
	g_hDb = SQL_Connect("aura", false, szError, 255);
	if(g_hDb == INVALID_HANDLE)
	{
		LogError("[Aura_db] Unable to connect to database (%s)", szError);
		PrintToServer("[Aura_db] Unable to connect to database");
		return;
	}
	
	decl String:szIdent[8];
	SQL_ReadDriver(g_hDb, szIdent, 8);
	//mysql/sqlite
	if(strcmp(szIdent, "mysql", false) == 0)
	{
		//g_DbType = MYSQL;
	}
	else if(strcmp(szIdent, "sqlite", false) == 0)//в плагине нет ф-ций которые различаются в sqlite и mysql.
	{ 
		//g_DbType = SQLITE;
	}
	else
	{
		LogError("[Aura_db] Invalid Database-Type");
		PrintToServer("[Aura_db] Invalid Database-Type");
		return;
	}
	db_createTables();
}

public db_createTables()
{
	SQL_LockDatabase(g_hDb);
	SQL_FastQuery(g_hDb, sql_createTables);
	SQL_UnlockDatabase(g_hDb);
}

//-----------------//
// global callback //
//-----------------//
public SQL_CheckCallback(Handle:owner, Handle:hndl, const String:error[], any:data){
	if(hndl == INVALID_HANDLE)
	{
		LogError("[Aura_db] Error inserting into database (%s)", error);
	}	
}